DevExtreme v26.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Data Grid - Deferred Selection

If you enable deferred row selection, the grid does not request selected rows' data with every selection change. For example, if a user clicks the checkbox in the column header to select all the rows, the grid does not immediately fetch all data from the server.

This is helpful in the following cases:

  • You process data on the server and do not want to load the selected rows' data.
  • You do process selected records on the client, but want to reduce the number of requests that are sent.
Backend API
$(() => { const url = 'https://js.devexpress.com/Demos/NetCore/api/TreeListTasks'; const MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24; let dataGrid; $('#grid-container').dxDataGrid({ dataSource: DevExpress.data.AspNet.createStore({ key: 'Task_ID', loadUrl: `${url}/Tasks`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }), remoteOperations: true, pager: { visible: true, }, selection: { mode: 'multiple', deferred: true, }, filterRow: { visible: true, }, onInitialized(e) { dataGrid = e.component; calculateStatistics(); }, selectionFilter: ['Task_Status', '=', 'Completed'], showBorders: true, columns: [{ caption: 'Subject', dataField: 'Task_Subject', }, { caption: 'Start Date', dataField: 'Task_Start_Date', width: 'auto', dataType: 'date', }, { caption: 'Due Date', dataField: 'Task_Due_Date', width: 'auto', dataType: 'date', }, { caption: 'Assigned To', dataField: 'Task_Assigned_Employee_ID', width: 'auto', allowSorting: false, lookup: { dataSource: DevExpress.data.AspNet.createStore({ key: 'ID', loadUrl: `${url}/TaskEmployees`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }), valueExpr: 'ID', displayExpr: 'Name', }, }, { caption: 'Status', width: 'auto', dataField: 'Task_Status', }], }).dxDataGrid('instance'); async function calculateStatistics() { const selectedItems = await dataGrid.getSelectedRowsData(); const totalDuration = selectedItems.reduce((currentValue, item) => { const dueDateTime = new Date(item.Task_Due_Date).getTime(); const startDateTime = new Date(item.Task_Start_Date).getTime(); const duration = dueDateTime - startDateTime; return currentValue + duration; }, 0); const averageDurationInDays = totalDuration / MILLISECONDS_IN_DAY / selectedItems.length; $('#tasks-count').text(selectedItems.length); $('#people-count').text( DevExpress.data.query(selectedItems) .groupBy('Task_Assigned_Employee_ID') .toArray().length, ); $('#avg-duration').text(Math.round(averageDurationInDays) || 0); } $('#calculateButton').dxButton({ text: 'Get statistics on the selected tasks', type: 'default', onClick: calculateStatistics, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" /> <script src="js/dx.all.js?v=26.1.3"></script> <script src="https://unpkg.com/devextreme-aspnet-data@5.0.0/js/dx.aspnet.data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="grid-container"></div> <div class="selection-summary center"> <div id="calculateButton"></div> <div> <div class="column"> <span class="text count">Task count:</span> <span class="value" id="tasks-count">0</span> </div> <div class="column"> <span class="text people-count">People assigned:</span> <span class="value" id="people-count">0</span> </div> <div class="column"> <span class="text avg-duration"> Average task duration (days): </span> <span class="value" id="avg-duration">0</span> </div> </div> </div> </div> </body> </html>
#grid-container { height: 400px; } .center { text-align: center; } .selection-summary { border: 1px solid rgba(161, 161, 161, 0.2); padding: 25px; } .column { margin: 20px 30px 0 0; display: inline-block; white-space: nowrap; text-align: right; } .value { font-size: 40px; display: inline-block; vertical-align: middle; } .text { text-align: left; white-space: normal; display: inline-block; vertical-align: middle; } .avg-duration { width: 100px; } .count { width: 40px; } .people-count { width: 65px; }

This demo illustrates the second scenario. Deferred selection is enabled and the selected rows are only requested when you click the button below the grid.

To enable deferred selection in your application, set the selection.deferred property to true.

To specify the initially selected rows, use the selectionFilter property. The JavaScript DataGrid updates this property's value at runtime and you can always access the applied filter. In this demo, the selectionFilter selects rows whose Status is Completed.

To load the selected rows' data, call the getSelectedRowsData() method. In deferred selection mode, this method returns a Promise. You can access row data in its fulfillment handler. In this demo, the getSelectedRowsData() method gets data objects that are then used to calculate statistics for the selected tasks.

import React, { useCallback, useState } from 'react';
import DataGrid, {
Column, FilterRow, Selection, Pager, Lookup,
} from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import Button from 'devextreme-react/button';
import { query } from 'devextreme-react/common/data';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24;
const url = 'https://js.devexpress.com/Demos/NetCore/api/TreeListTasks';
const tasksDataSource = createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const employeesDataSource = createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const selectionFilter = ['Task_Status', '=', 'Completed'];
let dataGrid: DataGridTypes.InitializedEvent['component'];
const App = () => {
const [taskCount, setTaskCount] = useState(0);
const [peopleCount, setPeopleCount] = useState(0);
const [avgDuration, setAvgDuration] = useState(0);
const calculateStatistics = useCallback(async () => {
const selectedItems = await dataGrid?.getSelectedRowsData() ?? [];
const totalDuration = selectedItems.reduce((currentValue: number, item: { Task_Due_Date: string; Task_Start_Date: string; }) => {
const dueDateTime = new Date(item.Task_Due_Date).getTime();
const startDateTime = new Date(item.Task_Start_Date).getTime();
const duration = dueDateTime - startDateTime;
return currentValue + duration;
}, 0);
const averageDurationInDays = totalDuration / MILLISECONDS_IN_DAY / selectedItems.length;
setTaskCount(selectedItems.length);
setPeopleCount(
query(selectedItems)
.groupBy('Task_Assigned_Employee_ID')
.toArray().length,
);
setAvgDuration(Math.round(averageDurationInDays) || 0);
}, []);
const onInitialized = useCallback((e: DataGridTypes.InitializedEvent) => {
dataGrid = e.component;
calculateStatistics();
}, [calculateStatistics]);
return (
<div>
<DataGrid
id="grid-container"
dataSource={tasksDataSource}
remoteOperations={true}
showBorders={true}
defaultSelectionFilter={selectionFilter}
onInitialized={onInitialized}
>
<Selection mode="multiple" deferred={true} />
<FilterRow visible={true} />
<Pager visible={true} />
<Column caption="Subject" dataField="Task_Subject" />
<Column
caption="Start Date"
dataField="Task_Start_Date"
width="auto"
dataType="date"
/>
<Column
caption="Due Date"
dataField="Task_Due_Date"
width="auto"
dataType="date"
/>
<Column
caption="Assigned To"
dataField="Task_Assigned_Employee_ID"
width="auto"
allowSorting={false}
>
<Lookup
dataSource={employeesDataSource}
valueExpr="ID"
displayExpr="Name"
/>
</Column>
<Column caption="Status" width="auto" dataField="Task_Status" />
</DataGrid>
<div className="selection-summary center">
<Button
id="calculateButton"
text="Get statistics on the selected tasks"
type="default"
onClick={calculateStatistics}
/>
<div>
<div className="column">
<span className="text count">Task count:</span>
<span className="value">{taskCount}</span>
</div>
<div className="column">
<span className="text people-count">People assigned:</span>
<span className="value">{peopleCount}</span>
</div>
<div className="column">
<span className="text avg-duration">Average task duration (days):</span>
<span className="value">{avgDuration}</span>
</div>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import DataGrid, {
Column, FilterRow, Selection, Pager, Lookup,
} from 'devextreme-react/data-grid';
import Button from 'devextreme-react/button';
import { query } from 'devextreme-react/common/data';
import { createStore } from 'devextreme-aspnet-data-nojquery';
const MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24;
const url = 'https://js.devexpress.com/Demos/NetCore/api/TreeListTasks';
const tasksDataSource = createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const employeesDataSource = createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
const selectionFilter = ['Task_Status', '=', 'Completed'];
let dataGrid;
const App = () => {
const [taskCount, setTaskCount] = useState(0);
const [peopleCount, setPeopleCount] = useState(0);
const [avgDuration, setAvgDuration] = useState(0);
const calculateStatistics = useCallback(async () => {
const selectedItems = (await dataGrid?.getSelectedRowsData()) ?? [];
const totalDuration = selectedItems.reduce((currentValue, item) => {
const dueDateTime = new Date(item.Task_Due_Date).getTime();
const startDateTime = new Date(item.Task_Start_Date).getTime();
const duration = dueDateTime - startDateTime;
return currentValue + duration;
}, 0);
const averageDurationInDays = totalDuration / MILLISECONDS_IN_DAY / selectedItems.length;
setTaskCount(selectedItems.length);
setPeopleCount(query(selectedItems).groupBy('Task_Assigned_Employee_ID').toArray().length);
setAvgDuration(Math.round(averageDurationInDays) || 0);
}, []);
const onInitialized = useCallback(
(e) => {
dataGrid = e.component;
calculateStatistics();
},
[calculateStatistics],
);
return (
<div>
<DataGrid
id="grid-container"
dataSource={tasksDataSource}
remoteOperations={true}
showBorders={true}
defaultSelectionFilter={selectionFilter}
onInitialized={onInitialized}
>
<Selection
mode="multiple"
deferred={true}
/>
<FilterRow visible={true} />
<Pager visible={true} />
<Column
caption="Subject"
dataField="Task_Subject"
/>
<Column
caption="Start Date"
dataField="Task_Start_Date"
width="auto"
dataType="date"
/>
<Column
caption="Due Date"
dataField="Task_Due_Date"
width="auto"
dataType="date"
/>
<Column
caption="Assigned To"
dataField="Task_Assigned_Employee_ID"
width="auto"
allowSorting={false}
>
<Lookup
dataSource={employeesDataSource}
valueExpr="ID"
displayExpr="Name"
/>
</Column>
<Column
caption="Status"
width="auto"
dataField="Task_Status"
/>
</DataGrid>
<div className="selection-summary center">
<Button
id="calculateButton"
text="Get statistics on the selected tasks"
type="default"
onClick={calculateStatistics}
/>
<div>
<div className="column">
<span className="text count">Task count:</span>
<span className="value">{taskCount}</span>
</div>
<div className="column">
<span className="text people-count">People assigned:</span>
<span className="value">{peopleCount}</span>
</div>
<div className="column">
<span className="text avg-duration">Average task duration (days):</span>
<span className="value">{avgDuration}</span>
</div>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#grid-container {
height: 400px;
}
.center {
text-align: center;
}
.selection-summary {
border: 1px solid rgba(161, 161, 161, 0.2);
padding: 25px;
}
.column {
margin: 20px 30px 0 0;
display: inline-block;
white-space: nowrap;
text-align: right;
}
.value {
font-size: 40px;
display: inline-block;
vertical-align: middle;
}
.text {
text-align: left;
white-space: normal;
display: inline-block;
vertical-align: middle;
}
.avg-duration {
width: 100px;
}
.count {
width: 40px;
}
.people-count {
width: 65px;
}

DevExtreme v25.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Data Grid - Deferred Selection

If you enable deferred row selection, the grid does not request selected rows' data with every selection change. For example, if a user clicks the checkbox in the column header to select all the rows, the grid does not immediately fetch all data from the server.

This is helpful in the following cases:

  • You process data on the server and do not want to load the selected rows' data.
  • You do process selected records on the client, but want to reduce the number of requests that are sent.
Backend API
<template> <div> <DxDataGrid id="grid-container" :data-source="tasksDataSource" :remote-operations="true" :show-borders="true" :selection-filter="selectionFilter" :on-initialized="onInitialized" > <DxSelection :deferred="true" mode="multiple" /> <DxPager :visible="true"/> <DxFilterRow :visible="true"/> <DxColumn caption="Subject" data-field="Task_Subject" /> <DxColumn caption="Start Date" data-field="Task_Start_Date" width="auto" data-type="date" /> <DxColumn caption="Due Date" data-field="Task_Due_Date" width="auto" data-type="date" /> <DxColumn :allow-sorting="false" caption="Assigned To" data-field="Task_Assigned_Employee_ID" width="auto" > <DxLookup :data-source="employeesDataSource" value-expr="ID" display-expr="Name" /> </DxColumn> <DxColumn caption="Status" width="auto" data-field="Task_Status" /> </DxDataGrid> <div class="selection-summary center"> <DxButton id="calculateButton" :on-click="calculateStatistics" text="Get statistics on the selected tasks" type="default" /> <div> <div class="column"> <span class="text count">Task count: </span> <span class="value">{{ taskCount }}</span> </div> <div class="column"> <span class="text people-count">People assigned: </span> <span class="value">{{ peopleCount }}</span> </div> <div class="column"> <span class="text avg-duration">Average task duration (days): </span> <span class="value">{{ avgDuration }}</span> </div> </div> </div> </div> </template> <script setup lang="ts"> import { ref } from 'vue'; import { DxDataGrid, DxColumn, DxFilterRow, DxSelection, type DxDataGridTypes, DxPager, DxLookup, } from 'devextreme-vue/data-grid'; import DxButton from 'devextreme-vue/button'; import { query } from 'devextreme-vue/common/data'; import { createStore } from 'devextreme-aspnet-data-nojquery'; const MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24; const url = 'https://js.devexpress.com/Demos/NetCore/api/TreeListTasks'; const tasksDataSource = createStore({ key: 'Task_ID', loadUrl: `${url}/Tasks`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }); const employeesDataSource = createStore({ key: 'ID', loadUrl: `${url}/TaskEmployees`, onBeforeSend(method, ajaxOptions) { ajaxOptions.xhrFields = { withCredentials: true }; }, }); let dataGrid: DxDataGrid['instance']; const selectionFilter = ['Task_Status', '=', 'Completed']; const taskCount = ref(0); const peopleCount = ref(0); const avgDuration = ref(0); const calculateStatistics = async () => { if (!dataGrid) return; const selectedItems = await dataGrid.getSelectedRowsData(); const totalDuration = selectedItems.reduce((currentValue, item) => { const dueDateTime = new Date(item.Task_Due_Date).getTime(); const startDateTime = new Date(item.Task_Start_Date).getTime(); const duration = dueDateTime - startDateTime; return currentValue + duration; }, 0); const averageDurationInDays = totalDuration / MILLISECONDS_IN_DAY / selectedItems.length; taskCount.value = selectedItems.length; peopleCount.value = query(selectedItems) .groupBy('Task_Assigned_Employee_ID') .toArray().length; avgDuration.value = Math.round(averageDurationInDays) || 0; }; const onInitialized = (e: DxDataGridTypes.InitializedEvent) => { dataGrid = e.component!; calculateStatistics(); }; </script> <style> #grid-container { height: 400px; } .center { text-align: center; } .selection-summary { border: 1px solid rgba(161, 161, 161, 0.2); padding: 25px; } .column { margin: 20px 30px 0 0; display: inline-block; white-space: nowrap; text-align: right; } .column:nth-child(2) { padding: 0 4px; } .value { font-size: 40px; display: inline-block; vertical-align: middle; } .text { text-align: left; white-space: normal; display: inline-block; vertical-align: middle; margin-right: 4px; } .avg-duration { width: 100px; } .count { width: 40px; } .people-count { width: 65px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'devextreme-aspnet-data-nojquery': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'project:': '../../../../', 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', 'anti-forgery:': '../../../../shared/anti-forgery/', }, map: { 'anti-forgery': 'anti-forgery:fetch-override.js', 'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js', '@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js', 'demo-ts-loader': 'project:utils/demo-ts-loader.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'svg-loader': 'project:utils/svg-loader.js', 'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.0.0/index.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs', 'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme-vue/common': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; window.process = { env: { NODE_ENV: 'production', }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.7/css/dx.light.css" /> <script type="module"> import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app" /> </div> </body> </html>

This demo illustrates the second scenario. Deferred selection is enabled and the selected rows are only requested when you click the button below the grid.

To enable deferred selection in your application, set the selection.deferred property to true.

To specify the initially selected rows, use the selectionFilter property. The DataGrid updates this property's value at runtime and you can always access the applied filter. In this demo, the selectionFilter selects rows whose Status is Completed.

To load the selected rows' data, call the getSelectedRowsData() method. In deferred selection mode, this method returns a Promise. You can access row data in its fulfillment handler. In this demo, the getSelectedRowsData() method gets data objects that are then used to calculate statistics for the selected tasks.

<dx-data-grid
id="grid-container"
[dataSource]="tasksDataSource"
[remoteOperations]="true"
[selectionFilter]="['Task_Status', '=', 'Completed']"
[showBorders]="true"
>
<dxo-data-grid-selection
mode="multiple"
[deferred]="true"
></dxo-data-grid-selection>
<dxo-data-grid-filter-row [visible]="true"></dxo-data-grid-filter-row>
<dxo-data-grid-pager [visible]="true"></dxo-data-grid-pager>
<dxi-data-grid-column
caption="Subject"
dataField="Task_Subject"
></dxi-data-grid-column>
<dxi-data-grid-column
caption="Start Date"
dataField="Task_Start_Date"
width="auto"
dataType="date"
></dxi-data-grid-column>
<dxi-data-grid-column
caption="Due Date"
dataField="Task_Due_Date"
width="auto"
dataType="date"
></dxi-data-grid-column>
<dxi-data-grid-column
caption="Assigned To"
dataField="Task_Assigned_Employee_ID"
width="auto"
[allowSorting]="false"
>
<dxo-data-grid-lookup
[dataSource]="employeesDataSource"
valueExpr="ID"
displayExpr="Name"
></dxo-data-grid-lookup>
</dxi-data-grid-column>
<dxi-data-grid-column
caption="Status"
dataField="Task_Status"
width="auto"
></dxi-data-grid-column>
</dx-data-grid>
<div class="selection-summary center">
<dx-button
id="calculateButton"
text="Get statistics on the selected tasks"
type="default"
(onClick)="calculateStatistics()"
></dx-button>
<div>
<div class="column">
<span class="text count">Task count:</span>
<span class="value">{{ taskCount }}</span>
</div>
<div class="column">
<span class="text people-count">People assigned:</span>
<span class="value">{{ peopleCount }}</span>
</div>
<div class="column">
<span class="text avg-duration">Average task duration (days):</span>
<span class="value">{{ avgDuration }}</span>
</div>
</div>
</div>
import {
Component, ViewChild, AfterViewInit, enableProdMode, provideZoneChangeDetection,
} from '@angular/core';
import { DxDataGridModule, DxDataGridComponent, DxButtonModule } from 'devextreme-angular';
import { query } from 'devextreme-angular/common/data';
import { bootstrapApplication } from '@angular/platform-browser';
import * as AspNetData from 'devextreme-aspnet-data-nojquery';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxDataGridModule,
DxButtonModule,
],
})
export class AppComponent implements AfterViewInit {
@ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent;
MILLISECONDS_IN_DAY = 1000 * 60 * 60 * 24;
tasksDataSource: AspNetData.CustomStore;
employeesDataSource: AspNetData.CustomStore;
taskCount = 0;
peopleCount = 0;
avgDuration = 0;
constructor() {
const url = 'https://js.devexpress.com/Demos/NetCore/api/TreeListTasks';
this.tasksDataSource = AspNetData.createStore({
key: 'Task_ID',
loadUrl: `${url}/Tasks`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
this.employeesDataSource = AspNetData.createStore({
key: 'ID',
loadUrl: `${url}/TaskEmployees`,
onBeforeSend(method, ajaxOptions) {
ajaxOptions.xhrFields = { withCredentials: true };
},
});
}
ngAfterViewInit() {
this.calculateStatistics();
}
async calculateStatistics() {
const selectedItems = await this.dataGrid.instance.getSelectedRowsData();
const totalDuration = selectedItems.reduce((currentValue, item) => {
const dueDateTime = new Date(item.Task_Due_Date).getTime();
const startDateTime = new Date(item.Task_Start_Date).getTime();
const duration = dueDateTime - startDateTime;
return currentValue + duration;
}, 0);
const averageDurationInDays = totalDuration / this.MILLISECONDS_IN_DAY / selectedItems.length;
this.taskCount = selectedItems.length;
this.peopleCount = query(selectedItems)
.groupBy('Task_Assigned_Employee_ID')
.toArray().length;
this.avgDuration = Math.round(averageDurationInDays) || 0;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #grid-container {
height: 400px;
}
::ng-deep .center {
text-align: center;
}
::ng-deep .selection-summary {
border: 1px solid rgba(161, 161, 161, 0.2);
padding: 25px;
}
::ng-deep .column {
margin: 20px 30px 0 0;
display: inline-block;
white-space: nowrap;
text-align: right;
}
::ng-deep .value {
font-size: 40px;
display: inline-block;
vertical-align: middle;
}
::ng-deep .text {
text-align: left;
white-space: normal;
display: inline-block;
vertical-align: middle;
}
::ng-deep .avg-duration {
width: 100px;
}
::ng-deep .count {
width: 40px;
}
::ng-deep .people-count {
width: 65px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme-aspnet-data-nojquery': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'devextreme-aspnet-data-nojquery': 'npm:devextreme-aspnet-data-nojquery@5.1.0/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "21.2.17"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>